use embassy_rp::pio::{Common, Instance, LoadedProgram};
use pio_proc::pio_file;

pub struct DhtProgram<'d, PIO: Instance> {
    program: LoadedProgram<'d, PIO>,
}

impl<'d, PIO: Instance> DhtProgram<'d, PIO> {
    pub fn new(pio: &mut Common<'d, PIO>) -> Self {
        let program = pio_file!("./src/dht.pio");
        Self {
            program: pio.load_program(&program.program),
        }
    }

    pub(crate) fn program(&self) -> &LoadedProgram<'d, PIO> {
        &self.program
    }
}
